//----------------------------------------------------------------------
//MODEULE: keypad40.c
//COMMON DESCRIPTION:
//  This module contain declaration for used serial keyboard (40 keys)
//----------------------------------------------------------------------
// Common declarations
//----------------------------------------------------------------------
#ifdef KEYPAD40_ENABLED
  //--------------------------------------------------------------------
  //    UART
  //--------------------------------------------------------------------
  #ifdef KEYPAD40_PROGUART
  //--------------------------------------------------------------------
  //   (8 )
  //   (   ! 2,4,8,16  ..)
  // ..     2  -   8
  //  ,  ,      
  // int keypad40_puart_getch();
  //--------------------------------------------------------------------
  #define KEYPAD40_PUART_BUFSIZE	8
  unsigned char keypad40_buf[KEYPAD40_PUART_BUFSIZE];
  unsigned char keypad40_bufb;
  unsigned char keypad40_bufe;
  //--------------------------------------------------------------------
  //  UART
  //--------------------------------------------------------------------
  //   UART
  #define KEYPAD40_PUART_WAIT		0x00	/*   */
  #define KEYPAD40_PUART_RECIEVE	0x01	/*  */
  #define KEYPAD40_PUART_FULLBUF	0x02	/*   */
  #define KEYPAD40_PUART_BYTELEN	0x09    /*      */
  //
  unsigned char keypad40_puart_str;  /*   */
  unsigned char keypad40_puart_bcnt; /*   */
  unsigned char keypad40_puart_char; /*   */
  //--------------------------------------------------------------------
  unsigned int  keypad40_puart_t1bit; 
  unsigned int  keypad40_puart_t15bit;
  //--------------------------------------------------------------------
  void keypad40_puart_init()
    {//
     KEYPAD40_PUART_DDR = KEYPAD40_PUART_DDR & (~(1<<KEYPAD40_PUART_P));
     keypad40_puart_str=KEYPAD40_PUART_WAIT;
     //
     keypad40_puart_t1bit=TIMER1_DEV_UART(KEYPAD40_PUART_SPEED);
     keypad40_puart_t15bit=keypad40_puart_t1bit+(keypad40_puart_t1bit>>1);
     //
    }
  //--------------------------------------------------------------------
  //    (  1  0)
  void keypad40_puart_int_handler()
    {//    -  
     if(keypad40_puart_str==KEYPAD40_PUART_WAIT)
       {//      1.5  
        // (       )
        timer1_setdevider(keypad40_puart_t15bit);
        timer1_reset();
        timer1_start();
        //      
        int0_disable();
        //   = 0
        keypad40_puart_bcnt=0;
        //  -  .
        keypad40_puart_str=KEYPAD40_PUART_RECIEVE;
       }
    }
  //--------------------------------------------------------------------
  //      
  //--------------------------------------------------------------------
  void keypad40_puart_timer_handler()
    {//   0  -    1
     if(!keypad40_puart_bcnt)
       {timer1_stop();
        timer1_setdevider(keypad40_puart_t1bit); 
        timer1_reset();
        timer1_start();
       }
     //   
     if(keypad40_puart_bcnt<0x08)
       {keypad40_puart_char = keypad40_puart_char >> 1;
        //    
        if(input(KEYPAD40_PUART_PIN) & (1<<KEYPAD40_PUART_P)){keypad40_puart_char |= 0x80;}
        else{keypad40_puart_char &= 0x7F;}
       }
     // 
     keypad40_puart_bcnt++;
     // 8  ?
     if((keypad40_puart_bcnt)==0x08)
        {//     
	 if( ((keypad40_bufe+1)&(KEYPAD40_PUART_BUFSIZE-1)) != keypad40_bufb)
	   {//    .  
	    keypad40_buf[keypad40_bufe]=keypad40_puart_char;
	    keypad40_bufe=(keypad40_bufe+1)&(KEYPAD40_PUART_BUFSIZE-1);
	    //     
	    keypad40_puart_str=KEYPAD40_PUART_WAIT;
	   }
	 else
	   {//   
	    keypad40_puart_str=KEYPAD40_PUART_FULLBUF;
	   }
	}
     //    ?
     if((keypad40_puart_bcnt)>=KEYPAD40_PUART_BYTELEN)
       {//  
	 timer1_stop();
	 //  
	 int0_enable();
       }
     //
    }
  //--------------------------------------------------------------------
  //     -1 (   )
  //--------------------------------------------------------------------
  int keypad40_puart_getch()
    {//    ?
     if(keypad40_bufb!=keypad40_bufe)
       {//     
        unsigned char ch = keypad40_buf[keypad40_bufb];
	keypad40_bufb=(keypad40_bufb+1)&(KEYPAD40_PUART_BUFSIZE-1);
        //     -   
        if(keypad40_puart_str==KEYPAD40_PUART_FULLBUF){keypad40_puart_str=KEYPAD40_PUART_WAIT;}
	//   
	return(ch);
       }
     else
       {//  
        return(-1);
       }
    }
  #endif /* KEYPAD40_PROGUART */
  //--------------------------------------------------------------------
  void keypad40_init()
    {//
     #ifdef KEYPAD40_PROGUART
     keypad40_puart_init();
     keypad40_bufb=keypad40_bufe=0; //  
     #endif /* KEYPAD40_PROGUART */
    }
  //--------------------------------------------------------------------
  //  
  //--------------------------------------------------------------------
  unsigned char keypad40_rcod_10[] PROGMEM =
                /* |  |  Fn |  Fn |*/
		{  0x10, 'q',     '1',
		   0x11, 'w',     '2',
		   0x12, 'e',     '3',
		   0x13, 'r',     '4',
		   0x14, 'j',     '\'',
		   0x15, 'k',     '\"',
		   0x16, 'l',     '@',
		   0x17, KEYPAD40_KEY_BACKSPC, KEYPAD40_KEY_BACKSPC,
		   0x18, KEYPAD40_KEY_PHONE,   KEYPAD40_KEY_MENU,
		   0x19, ' ',     ' ',   /* Speace    CapsLook */
		   0x1a, KEYPAD40_KEY_TODO,    KEYPAD40_KEY_CALC,
		   0x1b, KEYPAD40_KEY_DOWN,    KEYPAD40_KEY_DOWN
		};
  //
  unsigned char keypad40_rcod_20[] PROGMEM =
                /* |  |  Fn |  Fn |*/
		{  0x28, 'd',     '+',
		   0x29, 'f',     '-',
		   0x2a, 'g',	  '=',
		   0x2b, 'h',     ':',
		   0x2c, KEYPAD40_KEY_ENTER,   KEYPAD40_KEY_TAB,
		   0x2d, KEYPAD40_KEY_LEFT,    KEYPAD40_KEY_LEFT,
		   0x2e, KEYPAD40_KEY_RIGHT,   KEYPAD40_KEY_RIGHT,
		   0x2f, KEYPAD40_KEY_DATE,    KEYPAD40_KEY_APPS
		};
  //
  unsigned char keypad40_rcod_40[] PROGMEM =
                /* |  |  Fn |  Fn |*/
		{  0x48, KEYPAD40_KEY_DEL,     KEYPAD40_KEY_DEL,
		   0x49, 'm',     '.',
		   0x4a, 'n',     ',',
		   0x4b, 'b',     '!',
		   0x4c, 's',     '/',
		   0x4d, 'a',     '*',
		   0x4e, 'p',     '0',
		   0x4f, 'o',     '9',
		};
  //
  unsigned char keypad40_rcod_60[] PROGMEM =
                /* |  |  Fn |  Fn |*/
		{  0x62, KEYPAD40_KEY_MEMO,    KEYPAD40_KEY_FIND,
		   0x63, KEYPAD40_KEY_UP,      KEYPAD40_KEY_UP,
		   0x64, 'v',     '?',
		   0x65, 'c',     ')',
		   0x66, 'x',     '(',
		   0x67, 'z',     '$',
		   0x68, 'i',     '8',
		   0x69, 'u',     '7',
		   0x6a, 'y',     '6',
		   0x6b, 't',     '5'
		};
  //--------------------------------------------------------------------
  //  
  unsigned char keypad40_flags;
  // #define KEYPAD40_Fn	(1 << 0x00) /*  Fn  */
  // #define KEYPAD40_FCAPSLOOK	(1 << 0x01) /*  CapsLook  */
  //--------------------------------------------------------------------
  int keypad40_getch()
    {signed int ch;
     while(1)
       {if((ch=keypad40_puart_getch())>=0)
          {//    
	   //  Fn
           if(ch==KEYPAD40_Fn_KDN){KEYPAD40_SETF(KEYPAD40_Fn);}
	   else if(ch==KEYPAD40_Fn_KUP){KEYPAD40_RESF(KEYPAD40_Fn);}
           //    CapsLook  ?
	   else if((ch==KEYPAD40_SPC_KDN) && KEYPAD40_F(KEYPAD40_Fn)){KEYPAD40_INVF(KEYPAD40_FCAPSLOOK);}
	   //      
	   //    
	   else if(!(ch & 0x80))
	     {//   
	      unsigned char* tadr=0;
	      if((ch & 0xF0) ==0x10){tadr=(unsigned char*)keypad40_rcod_10;}
	      else if((ch & 0xF0) ==0x20){tadr=(unsigned char*)keypad40_rcod_20;}
	      else if((ch & 0xF0) ==0x40){tadr=(unsigned char*)keypad40_rcod_40;}
	      else if((ch & 0xF0) ==0x60){tadr=(unsigned char*)keypad40_rcod_60;}
	      //      
	      char minc = pgm_read_byte(tadr);minc = ch - minc;
	      //
	      if(KEYPAD40_F(KEYPAD40_Fn))
	        {ch = pgm_read_byte(tadr+(minc+minc+minc)+2);
		 return(ch);
		}
	      else
	        {ch = pgm_read_byte(tadr+(minc+minc+minc)+1);
		 if( (KEYPAD40_F(KEYPAD40_FCAPSLOOK)) && (ch>='a') && (ch<='z') )
		   {ch = ch + ('A'-'a');
		   }
		 return(ch);
		}
	      //
	     }
          }
       }
    }
  //--------------------------------------------------------------------
//----------------------------------------------------------------------
#endif /*  KEYPAD40_ENABLED */
