//----------------------------------------------------------------------
//MODEULE: keypad40.h
//COMMON DESCRIPTION:
//  This module contain headers for keypad40.c
//----------------------------------------------------------------------
// Common declarations
//----------------------------------------------------------------------
#ifdef KEYPAD40_ENABLED
  void keypad40_init();
  #define keypad40_init_mac() keypad40_init()
  int keypad40_puart_getch();
  //
  int keypad40_getch();
  //    Fn
  #define KEYPAD40_Fn_KDN	0x01
  //    Fn
  #define KEYPAD40_Fn_KUP	0x9e
  //    Speace
  #define KEYPAD40_SPC_KDN	0x19
  //    unsigned char keypad40_flags;
  extern unsigned char keypad40_flags;
  #define KEYPAD40_Fn		(1 << 0x00) /*  Fn  */
  #define KEYPAD40_FCAPSLOOK	(1 << 0x01) /*  CapsLook  */
  //
  #define KEYPAD40_SETF(x) keypad40_flags|=x;
  #define KEYPAD40_RESF(x) keypad40_flags&=(~x);
  #define KEYPAD40_INVF(x) keypad40_flags^=x;
  #define KEYPAD40_F(x)    (keypad40_flags & x)
  //--------------------------------------------------------------------
  //   
  //--------------------------------------------------------------------
  #define KEYPAD40_KEY_TAB	0x06
  #define KEYPAD40_KEY_LEFT	0x08
  #define KEYPAD40_KEY_RIGHT	0x09
  #define KEYPAD40_KEY_UP	0x0A
  #define KEYPAD40_KEY_DOWN	0x0B
  
  #define KEYPAD40_KEY_BACKSPC	0x0C
  #define KEYPAD40_KEY_ENTER	0x0D
  #define KEYPAD40_KEY_DEL	0x0E
    
  #define KEYPAD40_KEY_DATE	0x18
  #define KEYPAD40_KEY_APPS	0x19
  
  #define KEYPAD40_KEY_PHONE	0x1A
  #define KEYPAD40_KEY_MENU	0x1B
  
  #define KEYPAD40_KEY_TODO	0x1C
  #define KEYPAD40_KEY_CALC	0x1D
  
  #define KEYPAD40_KEY_MEMO	0x1E
  #define KEYPAD40_KEY_FIND	0x1F
  //--------------------------------------------------------------------
#else
  #define keypad40_init_mac()
#endif
//----------------------------------------------------------------------
