//----------------------------------------------------------------------
//MODEULE: spi.c
//COMMON DESCRIPTION:
//  This module provide SPI support.
//----------------------------------------------------------------------
#ifdef SPI_ENABLED
//----------------------------------------------------------------------
void spi_init()
  {// Master or slave init
   #ifdef SPI_MASTER
     // MASTER MODE
     SPI_PORT  = (1<<SPI_SS) | (1<<SPI_SCK);_NOP();_NOP();
     // Set MOSI and SCK output, all others input
     SPI_DDR  = (1<<SPI_SS) | (1<<SPI_MOSI) | (1<<SPI_SCK);_NOP();_NOP();
     // Enable SPI, Master, set clock rate fck/16, MSB first, SPI mode 3 !!!
     SPCR = (1<<SPE) | (1<<MSTR) | (1<<SPR1) | (1<<SPR0) | (1<<CPOL) | (1<<CPHA) ;_NOP();_NOP();
     //
     inp(SPSR); // dummy read status
   #else
     // SLAVE MODE
   #endif
  }
//----------------------------------------------------------------------
// One byte transfer
// Send byte c to slave device and return reading byte from slave device
//----------------------------------------------------------------------
#ifdef SPI_MASTER
//----------------------------------------------------------------------
void spi_pktstart(){SPI_PORT  = SPI_PORT & (~(1<<SPI_SS));}
void spi_pktend(){SPI_PORT  = SPI_PORT | (1<<SPI_SS);}
//----------------------------------------------------------------------
void spi_msend(unsigned char c)
  { // Start transmission 
    SPDR = c;
    // Wait for previous transmission complete
    while(!(inp(SPSR) & (1<<SPIF)));
  }
//----------------------------------------------------------------------
char spi_mrecv()
  {// Start dummy transmission 
   SPDR = 0xFF;_NOP();_NOP();
   // Wait for dummy transmission complete
   while(!(SPSR & (1<<SPIF))){}
   return(SPDR);
  }
//----------------------------------------------------------------------
char spi_mtransf(unsigned char c)
  {// Send byte
   spi_msend(c);
   // Return
   return(SPDR);
  }
//----------------------------------------------------------------------
// Send sendlen bytes from sendbuf, than
// recieved reclen bytes to recbuf
//----------------------------------------------------------------------
void spi_pkt_trs(char* cmdbuf, int cmdlen, char* sendbuf, int sendlen, char* recbuf, int reclen)
  {int i;
   //
   spi_pktstart();
   for(i=0;i<cmdlen;i++){spi_msend(*(cmdbuf++));}
   for(i=0;i<sendlen;i++){spi_msend(*(sendbuf++));}
   for(i=0;i<reclen;i++){*(recbuf++) = spi_mrecv();}
   spi_pktend();
  }
//----------------------------------------------------------------------
#endif /* SPI_MASTER */
//----------------------------------------------------------------------
#endif /* SPI_ENABLED */
//----------------------------------------------------------------------
