//----------------------------------------------------------------------
//MODEULE: spi.h
//COMMON DESCRIPTION:
//  //  This module contain headers for spi.c 
//----------------------------------------------------------------------
// Common declarations
//----------------------------------------------------------------------
#ifdef SPI_ENABLED
  void spi_init();
  #define spi_init_mac() spi_init()
  //
  #ifdef SPI_MASTER
    // Start packet (SS low)
    void spi_pktstart();
    // End packet (SS high)
    void spi_pktend();
    // Send byte in master mode
    void spi_msend(unsigned char c);
    // Recieved byte in master mode
    char spi_mrecv();
    // Transfer byte in master mode
    char spi_mtransf(unsigned char c);
    // Send command, data and rec data
    void spi_pkt_trs(char* cmdbuf, int cmdlen, char* sendbuf, int sendlen, char* recbuf, int reclen);
  #endif /* SPI_MASTER */
#else
  #define spi_init_mac()
#endif
//----------------------------------------------------------------------
