//----------------------------------------------------------------------
//MODEULE: uart0.h
//COMMON DESCRIPTION:
//  //  This module contain headers for uart0.c 
//----------------------------------------------------------------------
// Common declarations
//----------------------------------------------------------------------
#ifdef UART1_ENABLED
  void uart1_init();
  #define uart1_init_mac() uart1_init()
  #ifndef UART1_SPD_CONST
    // Set speed (speed in Bits/sec)
    void uart1_setspeed(unsigned int speed);
  #endif
  // Main Read-Write Procedures. 
  // (char* c) is a pointer to byte, which will be readed or written
  unsigned char uart1_wr(char* c);// Write to uart1 (or writing-buffer) If byte written sucefully,
                                  // function return TRUE, else function return FALSE
  unsigned char uart1_rd(char* c);// Read from uart1 (or reading-buffer) If byte readed sucefully,
                                  // function return TRUE (non-Zero), else function return FALSE (Zero)
  // Procedure for job with buffers
  #ifdef UART1_BUFFERS_ENABLED
  // Functions of clearing buffers
  void uart1_clear_rx_buf(); // recieve buffer
  void uart1_clear_tx_buf(); // transmitt buffer
  unsigned char uart1_txbuf_empty();// Returned TRUE if TX buffer is empty
  unsigned char uart1_rxbuf_empty();// Returned TRUE if RX buffer is empty
  #endif
  // Uart Strings Support
  #ifdef UART1_STR_ENABLED
    // Write string from RAM
    void uart1_wrstr(unsigned char* s);
    // Write string from Program Memory
    void uart1_p_wrstr(unsigned char* s);
    // Write number
    void uart1_wrint(unsigned int n);
  #endif
#else
  #define uart1_init_mac()
#endif
//----------------------------------------------------------------------
