//----------------------------------------------------------------------
// MODEULE: menu.c
// COMMON DESCRIPTION:
//   This module contain declaration for used menu
//----------------------------------------------------------------------
#ifdef  MENU_ENABLED
//----------------------------------------------------------------------
// Show menu
//----------------------------------------------------------------------
void menu_show(sMENU* menu)
  {unsigned char i=0;
   // Clear screen
   MENU_CLRSCR();
   // Cursor to begin of 1st string
   MENU_CURAT(0,0);
   //
   while(pgm_read_word(&(menu->items[i].item_type)))
     {MENU_OUTC(i+'1');MENU_OUTC(' ');i++;}
   // Cursor to begin of 2nd string
   MENU_CURAT(0,1);
   MENU_OUTS((char*)(&(menu->items[menu->item].item_str)));
   //
   MENU_CURAT(menu->item*2,0);
   //
  }
//----------------------------------------------------------------------
void menu_exec_item0(unsigned int itemtype, void* item)
  {key16_shift_off(KEY16_SHIFT_0);
   //
   if(itemtype == MIT_PROC)
     {// Procedure
      if(item){((pMENU_ITEM_PROC)item)();}
     }
   else if(itemtype == MIT_SUBMENU)
     {// Submenu
      if(item){menu_run((sMENU*)item);}
     }
  }
//----------------------------------------------------------------------
// Execute item
//----------------------------------------------------------------------
void menu_exec_item(sMENU* menu, unsigned char item)
  {unsigned int ch;
   key16_shift_off(KEY16_SHIFT_0);
   // Run item
   ch=pgm_read_word(&(menu->items[menu->item].item_type));
   if(ch == MIT_PROC)
     {// Procedure
      ch=pgm_read_word(&(menu->items[menu->item].item));
      if(ch){((pMENU_ITEM_PROC)ch)();}
     }
   else if(ch == MIT_SUBMENU)
     {// Submenu
      ch=pgm_read_word(&(menu->items[menu->item].item));
      if(ch){menu_run((sMENU*)ch);}
     }
  }
//----------------------------------------------------------------------
// Run menu
//----------------------------------------------------------------------
void menu_run(sMENU* menu)
  {signed int ch;
   //
   while(1)
     {menu_show(menu);
      key16_shift_on(KEY16_SHIFT_0);
      //
      while((ch=MENU_GETC())<0){}
      //
      if(ch==MENU_KEY_PREV)
        {// <--
	 if(menu->item)
	   {menu->item--;}
	}
      else if(ch==MENU_KEY_NEXT)
        {// -->
	 if(pgm_read_word(&(menu->items[menu->item+1].item_type)))
	   {menu->item++;}
	}
      else if(ch==MENU_KEY_ENTER)
        {// Execute item
	 menu_exec_item(menu, menu->item);
        }
      else if(ch==MENU_KEY_ESC)
        {// Exit menu
         break;
        }
      //
      #ifdef MENU_FASTKEY_DIGITS
      else if((ch>='1')&&(ch<='9'))
        {// Fast execute items. keys '1'-'9'
         unsigned char i=0;
	 //
	 while(pgm_read_word(&(menu->items[i].item_type)))
	   {if(ch==(i+'1'))
	      {// Execute item
	       menu->item = i;
               menu_exec_item(menu, menu->item);
	       // Exit
	       break;
	      }
	    i++;
	   }
        }
      #endif /* MENU_FASTKEY_DIGITS */
      // Hotkeys
      else if(menu->hkeys[0]!=-1)
        {if(menu->hkeys[0]==ch)
	   {menu_exec_item0(pgm_read_word(&(menu->hkitems[0].item_type)),
	                    (void*)pgm_read_word(&(menu->hkitems[0].item)));
	   }
	}
     }
  }
//----------------------------------------------------------------------
#endif  /* MENU_ENABLED */
//----------------------------------------------------------------------
