//----------------------------------------------------------------------
// MODEULE: menu.h
// COMMON DESCRIPTION:
//   This module contain declaration for used menu
//----------------------------------------------------------------------
#ifdef  MENU_ENABLED
//----------------------------------------------------------------------
#define menu_init_mac()
//----------------------------------------------------------------------
// Procedure of execute of menu item
typedef void (*pMENU_ITEM_PROC) ();// Pointer to procedure
//----------------------------------------------------------------------
// Types of items (sMENU_ITEM.item_type)
#define MIT_ENDMENU	0x00 /* END item */
#define MIT_PROC	0x01 /* Procedure. 'item' - pointer of procedure */
#define MIT_SUBMENU	0x02 /* Submenu. 'item' - pointer of sMENU */
//----------------------------------------------------------------------
// sMENU_ITEM defines ONLY in program memory
typedef struct sMENU_ITEM
  {const unsigned int item_type; // type of item
   const void* item; // item
   char  item_str[MENU_MAX_REML+1]; // item description
  }sMENU_ITEM;
//----------------------------------------------------------------------
// // sMENU defines ONLY in data memory
typedef struct sMENU
  {const sMENU_ITEM*		items;  // pointer to items
   const sMENU_ITEM*		hkitems; // pointer to item (on hot-key, 4-maximum)
   signed int hkeys[0x04]; // Hotkeys code (maximum - 4), -1=no hotkey
   unsigned char		item;   // Number of current item
  }sMENU;
//----------------------------------------------------------------------
void menu_show(sMENU* menu);
void menu_run(sMENU* menu);
//----------------------------------------------------------------------
#else
#define menu_init_mac()
//----------------------------------------------------------------------
#endif  /* MENU_ENABLED */
//----------------------------------------------------------------------
