//------------------------------------------------------------------------------
// compincs.h
//        
//   avr-libc
//------------------------------------------------------------------------------
#ifndef _COMPINCS_H_
#define _COMPINCS_H_ 1
//------------------------------------------------------------------------------
#ifndef _CLI
#define _CLI() __asm__ __volatile__ ("cli")
#endif
//------------------------------------------------------------------------------
#ifndef _SEI
#define _SEI() __asm__ __volatile__ ("sei")
#endif
//------------------------------------------------------------------------------
#ifndef _NOP
#define _NOP() __asm__ __volatile__ ("nop")
#endif
//------------------------------------------------------------------------------
#ifndef _WDR
#define _WDR() __asm__ __volatile__ ("wdr")
#endif
//------------------------------------------------------------------------------
#ifndef _SLEEP
#define _SLEEP() __asm__ __volatile__ ("sleep")
#endif
//------------------------------------------------------------------------------
#ifndef _OPC
#define _OPC(op) __asm__ __volatile__ (".word %0" : : "n" (op))
#endif
//------------------------------------------------------------------------------
#include <avr/pgmspace.h>
//------------------------------------------------------------------------------
#ifndef _LPM
#define _LPM(x) __LPM(x)
#endif
#ifndef _ELPM
#define _ELPM(x) __ELPM(x)
#endif
//------------------------------------------------------------------------------
#include <avr/eeprom.h>
//------------------------------------------------------------------------------
#ifndef input
#define input(port) (port)
#endif
//------------------------------------------------------------------------------
#ifndef output
#define output(port, val) (port = val)
#endif
//------------------------------------------------------------------------------
#ifndef __inp_blk__
#define __inp_blk__(port, addr, cnt, op) {	\
	unsigned char __i = (cnt);		\
	unsigned char *__addr = (addr);		\
	while (__i) {				\
		*(__addr op) = input(port);	\
		__i--;				\
	}					\
 }
#endif
//------------------------------------------------------------------------------
#ifndef input_block_inc
#define input_block_inc(port, addr, cnt) __inp_blk__(port, addr, cnt, ++)
#endif
//------------------------------------------------------------------------------
#ifndef input_block_dec
#define input_block_dec(port, addr, cnt) __inp_blk__(port, addr, cnt, --)
#endif
//------------------------------------------------------------------------------
#ifndef __out_blk__
#define __out_blk__(port, addr, cnt, op) {	\
	unsigned char __i = (cnt);		\
	const unsigned char *__addr = (addr);	\
	while (__i) {				\
		output(port, *(__addr op));	\
		__i--;				\
	}					\
 }
#endif
//------------------------------------------------------------------------------
#ifndef output_block_inc
#define output_block_inc(port, addr, cnt) __out_blk__(port, addr, cnt, ++)
#endif
//------------------------------------------------------------------------------
#ifndef output_block_dec
#define output_block_dec(port, addr, cnt) __out_blk__(port, addr, cnt, --)
#endif
//------------------------------------------------------------------------------
#endif

