//----------------------------------------------------------------------
//MODEULE: at45db081.h
//COMMON DESCRIPTION:
//   This module contain declaration for used FLASH ROM AT45DB081 
//----------------------------------------------------------------------
// Enables support ch
// #define AT45DB081_ENABLE
//----------------------------------------------------------------------
#ifdef AT45DB081_ENABLE
//----------------------------------------------------------------------
// Macros:
//	  AT45DB081_SPI_TRANSFER(..)
// This macros send sendlen bytes from sendbuf, than
// recieved reclen bytes to recbuf.
//
// sendbuf (char*) - adress of buffer, containing data for send.
// sendlen (int)   - length of data for send.
// recbuf  (char*) - adress of buffer for recieved data.
// recdlen (int)   - length of recieved data.
//
// This macros used for SPI transfer.
// SPI interface must be init before use it. If you use standart SPI module (../hl/spi.c),
// you must enable and configure SPI by change file ../system/res_spi.h
//
// By default used procedure spi_pkt_trs(...) from ../hl/spi.c module,
// but user may redefine this macros, if he wonted use non-internal SPI
// interface.
//----------------------------------------------------------------------
#define AT45DB081_SPI_TRANSFER(cmdbuf, cmdlen, sendbuf, sendlen, recbuf, reclen) \
                   spi_pkt_trs(cmdbuf, cmdlen, sendbuf, sendlen, recbuf, reclen)
//----------------------------------------------------------------------
#define	FS_MARKER	"NedoPC.FLFS.0"
#define	FS_VERSION	"v.00.00.00"
//----------------------------------------------------------------------
// Pages
#define AT45DB081_PAGES		0x1000L
// Page size
#define AT45DB081_PAGESIZE	0x0108L
// User page size (without sysinfo)
#define AT45DB081_UPAGESIZE	0x0100L
//----------------------------------------------------------------------
#endif
//----------------------------------------------------------------------
