//----------------------------------------------------------------------
// MODEULE: res_key16.h
// COMMON DESCRIPTION:
//   This module contain declaration for used matrix keyboard (16 keys)
//----------------------------------------------------------------------
//   Resorce of keyboard:
// KEY16_ENABLED - if it symbol defined then keyboard will be inited and enabled
// Keyboard is matrix 4x4.
//
//       |'1' |'2' |'3' |'A'
//  4 -- | -- | -- | -- | --
//       |'4' |'5' |'6' |'B'
//  5 -- | -- | -- | -- | --
//       |'7' |'8' |'9  |'C'
//  6 -- | -- | -- | -- | --
//       |'*' |'0' |'#' |'D'
//  7 -- | -- | -- | -- | --
//       |    |    |    |
//       0    1    2    3
//
// Bits 0..3 - inputs  of port, defined as KEY16_PIN.
// Bits 4..7 - outputs of port, defined as KEY16_PORT.
//
// Notice, that KEY16_PORT and KEY16_PIN is a one port and
// it controlled by KEY16_DDR register
//----------------------------------------------------------------------
// #define KEY16_ENABLED
//----------------------------------------------------------------------
#ifdef  KEY16_ENABLED
//----------------------------------------------------------------------
#define KEY16_PORT	PORTF
#define KEY16_PIN	PINF
#define KEY16_DDR	DDRF
//
#define KEY16_KTIME	20 /* Timeout 200ms */
//----------------------------------------------------------------------
// Mask for SHIFT0 key
#define KEY16_SHIFT0_COL	0x01 /* Column */
#define KEY16_SHIFT0_ROW	0x03 /* Row */
//----------------------------------------------------------------------
#endif  /* KEY16_ENABLED */
//----------------------------------------------------------------------
