//----------------------------------------------------------------------
// MODEULE: menu.h
// COMMON DESCRIPTION:
//   This module contain declaration for used menu
//----------------------------------------------------------------------
// ENABLES MENU USING
// #define MENU_ENABLED
//----------------------------------------------------------------------
#ifdef  MENU_ENABLED
//----------------------------------------------------------------------
// Macroses for output on screen
//----------------------------------------------------------------------
// Clear screen
#define MENU_CLRSCR()	wp1602_ni15_showc(1); \
			wp1602_ni15_clear()			
// Position of cursor
#define MENU_CURAT(x,y) wp1602_ni15_curat(x, y)
// Output one char
#define MENU_OUTC(c)	wp1602_ni15_outc(c)
// Output string from ROM
#define MENU_OUTS(s)	wp1602_ni15_outsrom(s)
// Get symbol for menu control
//----------------------------------------------------------------------
// Get symbol from keyboard 
// (return as 'signed int' symbol code or -1 if no key pressed)
//----------------------------------------------------------------------
#define MENU_GETC()	key16_get()
//----------------------------------------------------------------------
// Maximum length of remark
//----------------------------------------------------------------------
#define MENU_MAX_REML	0x10
//----------------------------------------------------------------------
// Keyboard definitions
//----------------------------------------------------------------------
#define MENU_KEY_PREV	'*' /* Key for jumping to previous menu item */
#define MENU_KEY_NEXT	'#' /* Key for jumping to next menu item */
#define MENU_KEY_ENTER	'D' /* Key for execute menu item */
#define MENU_KEY_ESC	'C' /* Key for exit from menu */
//----------------------------------------------------------------------
// if symbol MENU_FASTKEY_DIGITS defined, you may used symbols '1'-'9'
// for fast execute menu items
#define MENU_FASTKEY_DIGITS
//----------------------------------------------------------------------
#endif  /* MENU_ENABLED */
//----------------------------------------------------------------------
